-- CombatCam by Everglow
-- version 4.3.1

-- View 1 = 1st person, accessed by slash command ("/ccam 0")
-- View 2 = Combat View
-- View 3 = Default out-of-combat view
-- View 4 = Custom view 1 ("/ccam 1")
-- View 5 = Custom view 2 ("/ccam 2")

useCC = "false";
useLC = "false";
combatView = 3;
-- local vars
local CC_Ver="4.3.1";
local CCTag="|c00FFFF66CombatCam "..CC_Ver.."|r: ";
local infotext =
	"|c0000FFFFUse this window to set your views.\n\n"..
	"/ccam or /combatcam opens this window\n\n"..
	"Commands:|r\n"..
	"/ccam 0:           first person view\n"..
	"/ccam [def/1/2/3]: zoom to a view\n"..
	"/ccam [c1/c2/c3]:  set combat view";
	
local CCtimer = 1.1;
local LeapTable = {}
	LeapTable[100]=1;
	LeapTable[16979]=1;
	LeapTable[36554]=1;
	LeapTable[49376]=1;
	LeapTable[80964]=1;
	LeapTable[80965]=1;

-- local functions
local function cMsg(msg)
	DEFAULT_CHAT_FRAME:AddMessage(msg);
end

local function StrToBool(value)
	if(value == "false") then return false; else return true; end
end

local function handler(arg)
	if (arg == "0") then
		SetView(1);
	elseif (arg == "1" or arg == "2" or arg == "3") then
		SetView(arg+2);
	elseif (arg == "def") then
		SetView(2);
	elseif (arg == "c1") then
		combatView = 3;
	elseif (arg == "c2") then
		combatView = 4;
	elseif (arg == "c3") then
		combatView = 5;
	else
		CombatCamFrame:Show();
	end
end

-- global functions
function CombatCamToggle(frame)
	if (useCC == "false") then useCC = "true"; else useCC = "false"; end
	if (useCC == "true") then
		frame:RegisterEvent("PLAYER_REGEN_DISABLED");
		frame:RegisterEvent("PLAYER_REGEN_ENABLED");
	else
		frame:UnregisterEvent("PLAYER_REGEN_DISABLED");
		frame:UnregisterEvent("PLAYER_REGEN_ENABLED");
	end
end

function LeapCamToggle(frame)
	if (useLC == "false") then useLC = "true"; else useLC = "false"; end
	if (useLC == "true") then
		frame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED");
	else
		frame:UnregisterEvent("UNIT_SPELLCAST_SUCCEEDED");
	end
end

function CCSetCView(view)
	combatView = view;
end

function CombatCam_OnLoad(frame)
	frame:RegisterEvent("PLAYER_LOGIN")
	getglobal(CombatCamEnableCheckButton:GetName() .. "Text"):SetText("Enable CombatCam");
	getglobal(LeapCamEnableCheckButton:GetName() .. "Text"):SetText("Enable LeapCam");
	getglobal(CombatCamUseView1Check:GetName() .. "Text"):SetText("combat view");
	getglobal(CombatCamUseView2Check:GetName() .. "Text"):SetText("combat view");
	getglobal(CombatCamUseView3Check:GetName() .. "Text"):SetText("combat view");
	CombatCamInfoText:SetWidth("250")

-- slash commands
	SLASH_COMBATCAM1 = "/combatcam"
	SLASH_COMBATCAM2 = "/ccam"
	SlashCmdList["COMBATCAM"] =	handler;
end
	
function CombatCam_OnEvent(frame, event, ...)
	if (event == "PLAYER_LOGIN") then
		-- initialize frame
		CombatCamInfoText:SetText(infotext)
		cMsg(CCTag.."Loaded")
		CombatCamEnableCheckButton:SetChecked(StrToBool(useCC))
		LeapCamEnableCheckButton:SetChecked(StrToBool(useLC))
		if combatView == 3 then
			CombatCamUseView1Check:SetChecked(true)
		elseif combatView == 4 then
			CombatCamUseView2Check:SetChecked(true)
		elseif combatView == 5 then
			CombatCamUseView3Check:SetChecked(true)
		end
		if useCC == "true" then
			frame:RegisterEvent("PLAYER_REGEN_DISABLED");
			frame:RegisterEvent("PLAYER_REGEN_ENABLED");
		end
		if useLC == "true" then
			frame:RegisterEvent("UNIT_SPELLCAST_SUCCEEDED");
		end
		frame:UnregisterEvent("PLAYER_LOGIN")
	elseif event == "PLAYER_REGEN_DISABLED" then SetView(combatView) -- player enters combat ---
	elseif event == "PLAYER_REGEN_ENABLED" then	SetView(2) -- player leaves combat ---
	elseif event == "UNIT_SPELLCAST_SUCCEEDED" then
		local delay = GetTime()-CCtimer;
		if ((delay > .1) and (delay < 3)) then 
			SetView(combatView);
			CCtimer = 1.1;
			cMsg("RAWR!!");
		else
			local castBy,_,_,_,spellID = ...;
			if ((castBy == "player") and LeapTable[spellID]) then
				CCtimer = GetTime();
			end
		end
	end
end